using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace PowerManagement
{
    public partial class Form1 : Form
    {
        private int chargeTimerCnt = 0;
        private byte ChgCmd = 0x3f;     //powered by all soure and turn on all channel
        private short chgCurrent = 0;    //full current charge

        private short chgStatus = 0;
        private short PowerPath = 0;
        private short chgPath = 0;
        private double refVol = 0;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            tmrCharge.Enabled = false;
            robotPWRM.connectRobot ("power");
            robotPWRM.SendCmdCHG(ChgCmd);
            robotPWRM.ChgCtrl((short)chgCurrent);

            


        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            lblChargeTimer.Text = trackBar1.Value.ToString();
            
        }

        private void robotPWRM_CustomSensorEvent(object sender, EventArgs e)
        {
            chgStatus = robotPWRM.GetCHGStatus();
            chgPath = robotPWRM.GetCHGPath();
            PowerPath = robotPWRM.GetPowerPath();
            if (robotPWRM.GetVolRef() != 0 ) 
                refVol = 1.5 * 4095/ (double) robotPWRM.GetVolRef();

            lblBat1Vol.Text = ( (double)robotPWRM.GetBat1Vol() / 4095 * refVol * 8).ToString("0.00") + "V";
            lblBat2Vol.Text = ((double)robotPWRM.GetBat2Vol() / 4095 * refVol * 8).ToString("0.00") + "V";
            lblDCINVol.Text = ((double)robotPWRM.GetDCINVol() / 4095 * refVol * 8).ToString("0.00") + "V";


            lblBat1Temp.Text = robotPWRM.GetBat1Temp().ToString();
            lblBat2Temp.Text = robotPWRM.GetBat2Temp().ToString(); ;

            if ((robotPWRM.GetBat1Temp() < 1100) || (robotPWRM.GetBat2Temp() < 1100))
            {
                //must stop charge
                ChgCmd = (byte)((int)ChgCmd & 0x3f);
                robotPWRM.SendCmdCHG(ChgCmd);
                tmrCharge.Enabled = false;
            }

            lblChargeStatus.Text = chgStatus.ToString();
            lblChgPath.Text = chgPath.ToString();
            lblPowerPath.Text = PowerPath.ToString();

            if ((PowerPath & 0x80) != 0)
            {
                //power by battery1
                btnBattery1PWR.BackColor = Color.Red;
            }
            else
            {
                btnBattery1PWR.BackColor = SystemColors.Control;
            }

            if ((PowerPath & 0x40) != 0)
            {
                //power by battery2
                btnBattery2PWR.BackColor = Color.Red;
            }
            else
            {
                btnBattery2PWR.BackColor = SystemColors.Control;
            }

            if ((PowerPath & 0x20) != 0)
            {
                //power by DCIN
                btnDCINPWR.BackColor = Color.Red;
            }
            else
            {
                btnDCINPWR.BackColor = SystemColors.Control;
            }

            if ((chgPath & 0x80) != 0)
            {
                //chg battery1
                btnBattery1CHG.BackColor = Color.Red;
            }
            else
            {
                btnBattery1CHG.BackColor = SystemColors.Control;
            }

            if ((chgPath & 0x40) != 0)
            {
                //chg battery2
                btnBattery2CHG.BackColor = Color.Red;
            }
            else
            {
                btnBattery2CHG.BackColor = SystemColors.Control;
            }


            if ((chgStatus & 0x40) != 0)
            {
                //in charge
                if ((tmrCharge.Enabled == false) && ( chargeTimerCnt < int.Parse(lblChargeTimer.Text)))
                {
                    chargeTimerCnt = 0;
                    tmrCharge.Enabled = true;
                }
                else
                {
                    tmrCharge.Enabled = false;
                }
            }

        }

        private void btnBattery1PWR_Click(object sender, EventArgs e)
        {
            if (btnBattery1PWR.BackColor != Color.Red)
            {
                //using battery1
                ChgCmd = (byte)((int)ChgCmd | 0x20);
                robotPWRM.SendCmdCHG(ChgCmd);
            }
            else
            {
                //not using battery1
               ChgCmd = (byte)((int)ChgCmd & 0xdf );
               robotPWRM.SendCmdCHG(ChgCmd);
            }
        }

        private void btnBattery2PWR_Click(object sender, EventArgs e)
        {
            if (btnBattery2PWR.BackColor != Color.Red)
            {
                //using battery2
                ChgCmd = (byte)((int)ChgCmd | 0x10);
                robotPWRM.SendCmdCHG(ChgCmd);
            }
            else
            {
                //not using battery2
                ChgCmd = (byte)((int)ChgCmd & 0xef);
                robotPWRM.SendCmdCHG(ChgCmd);
            }
        }

        private void btnDCINPWR_Click(object sender, EventArgs e)
        {
            if (btnDCINPWR.BackColor != Color.Red)
            {
                //using DCIN
                ChgCmd = (byte)((int)ChgCmd | 0x8);
                robotPWRM.SendCmdCHG(ChgCmd);
            }
            else
            {
                //not using DCIN
                ChgCmd = (byte)((int)ChgCmd & 0xf7);
                robotPWRM.SendCmdCHG(ChgCmd);
            }
        }

        private void btnBattery1CHG_Click(object sender, EventArgs e)
        {
            if (btnBattery1CHG.BackColor != Color.Red)
            {
                //charge battery1
                ChgCmd = (byte)((int)ChgCmd | 0x80);
                robotPWRM.SendCmdCHG(ChgCmd);
                if (tmrCharge.Enabled == false)
                    chargeTimerCnt = 0;
            }
            else
            {
                //not chargebattery1
                ChgCmd = (byte)((int)ChgCmd & 0x7f);
                robotPWRM.SendCmdCHG(ChgCmd);
            }
        }

        private void btnBattery2CHG_Click(object sender, EventArgs e)
        {
            if (btnBattery2CHG.BackColor != Color.Red)
            {
                //charge battery2
                ChgCmd = (byte)((int)ChgCmd | 0x40);
                robotPWRM.SendCmdCHG(ChgCmd);
                if (tmrCharge.Enabled == false)
                    chargeTimerCnt = 0;
            }
            else
            {
                //not chargebattery2
                ChgCmd = (byte)((int)ChgCmd & 0xbf);
                robotPWRM.SendCmdCHG(ChgCmd);
            }
        }

        private void btnChargeAll_Click(object sender, EventArgs e)
        {
            if (btnChargeAll.Text == "ChargeAll")
            {
                //charge battery1 and battery2
                ChgCmd = (byte)((int)ChgCmd | 0xc0);
                robotPWRM.SendCmdCHG(ChgCmd);
                btnChargeAll.Text = "Stop";
                if (tmrCharge.Enabled == false)
                    chargeTimerCnt = 0;
            }
            else
            {
                //not charge battery1 and battery2
                ChgCmd = (byte)((int)ChgCmd & 0x3f);
                robotPWRM.SendCmdCHG(ChgCmd);
                btnChargeAll.Text = "ChargeAll";
            }
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1.Checked == true)
            {
                chgCurrent = 0;
                robotPWRM.ChgCtrl(chgCurrent);
            }
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton2.Checked == true)
            {
                chgCurrent = 1;
                robotPWRM.ChgCtrl(chgCurrent);
            }
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton3.Checked == true)
            {
                chgCurrent = 2;
                robotPWRM.ChgCtrl(chgCurrent);
            }
        }

        private void radioButton4_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton4.Checked == true)
            {
                chgCurrent = 3;
                robotPWRM.ChgCtrl(chgCurrent);
            }
        }

        private void btnChannel1_Click(object sender, EventArgs e)
        {
            if (btnChannel1.Text == "Channel1 OFF")
            {
                // Option
            }
        }

        private void btnChannel2_Click(object sender, EventArgs e)
        {
          
                ChgCmd = (byte)((int)ChgCmd & 0xfd);
                robotPWRM.SendCmdCHG(ChgCmd);
                ChgCmd = (byte)((int)ChgCmd | 0x2);
           
        }

        private void btnChannel3_Click(object sender, EventArgs e)
        {
            if (btnChannel3.Text == "Channel3 OFF")
            {
                btnChannel3.Text = "Channel3 ON";
                ChgCmd = (byte)((int)ChgCmd & 0xfb);
                robotPWRM.SendCmdCHG(ChgCmd);
            }
            else
            {
                btnChannel3.Text = "Channel3 OFF";
                ChgCmd = (byte)((int)ChgCmd | 0x4);
                robotPWRM.SendCmdCHG(ChgCmd);
            }
        }

        private void tmrCharge_Tick(object sender, EventArgs e)
        {
            chargeTimerCnt++;
            if (chargeTimerCnt >= int.Parse(lblChargeTimer.Text)*60)
            {
                tmrCharge.Enabled = false;
                //stop charge here
                ChgCmd = (byte)((int)ChgCmd & 0x3f);
                robotPWRM.SendCmdCHG(ChgCmd);
            }
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start("http://www.drrobot.com");
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            Close();
        }
















        
       
    }
}